找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 2362|回复: 9

[每日一码] 模拟ZOOM命令的ARX代码

[复制链接]

已领礼包: 40个

财富等级: 招财进宝

发表于 2017-1-24 12:23:39 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
////////////////////////////////////////////////////////////////////////////
//
// This is command 'ZOOMEXT, by Fenton Webb [Apr/17/2002], DevTech, Autodesk
void asdkzoomExt()
{
        // get the extents of the drawing
        AcDbViewTableRecord view;
        AcGePoint3d max =
                acdbHostApplicationServices()->workingDatabase()->extmax(),
                min = acdbHostApplicationServices()->workingDatabase()->extmin();

        AcGePoint2d max_2d (max, max);
        AcGePoint2d min_2d (min, min);
        // now set the view centre point
        view.setCenterPoint (min_2d + (max_2d - min_2d) / 2.0);
        // now height and width of view
        view.setHeight(max_2d - min_2d);
        view.setWidth (max_2d - min_2d);
        // set the view
        acedSetCurrentView (&view, NULL);
        // updates the extents
        acdbHostApplicationServices()->workingDatabase()->updateExt(TRUE);
}

////////////////////////////////////////////////////////////////////////////
//
// This is command 'ZOOMWIN, by Fenton Webb [Apr/17/2002], DevTech, Autodesk
void asdkzoomWin()
{
        AcGePoint3d max, min;
        // get the window coords
        int res = acedGetPoint (NULL, "\nPick zoom window pnt : ",
                asDblArray(min));
        // if ok
        if (res == RTNORM)
        {
                res = acedGetCorner (asDblArray(min), "\nPick other corner : ",
                        asDblArray(max));
                // get the extents of the drawing
                AcDbViewTableRecord view;

                AcGePoint2d max_2d (max, max);
                AcGePoint2d min_2d (min, min);
                // now set the view centre point
                view.setCenterPoint (min_2d + (max_2d - min_2d) / 2.0);
                // now height and width of view
                view.setHeight(max_2d - min_2d);
                view.setWidth (max_2d - min_2d);
                // set the view
                acedSetCurrentView (&view, NULL);
                // updates the extents
                acdbHostApplicationServices()->workingDatabase()->updateExt(TRUE);
        }
}

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 6565个

财富等级: 富甲天下

发表于 2017-1-25 00:21:16 | 显示全部楼层
謝謝版主的提供,來學習一下!!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 86个

财富等级: 招财进宝

发表于 2017-1-28 08:38:13 | 显示全部楼层
啥也不说了,感谢楼主分享哇!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 86个

财富等级: 招财进宝

发表于 2017-1-29 09:26:21 | 显示全部楼层
正需要,支持楼主大人了!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 35个

财富等级: 招财进宝

发表于 2017-1-29 09:33:14 | 显示全部楼层
感觉很有用,已经用到了
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 2772个

财富等级: 家财万贯

发表于 2017-1-30 20:40:31 | 显示全部楼层
好资料,学习了。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 1个

财富等级: 恭喜发财

发表于 2017-2-13 11:10:44 | 显示全部楼层
vs2005下测试有点问题,主要是参数问题,改了一下:
void  asdkzoomExt()
{
         //get the extents of the drawing
        AcDbViewTableRecord view;
        AcGePoint3d max =
                acdbHostApplicationServices()->workingDatabase()->extmax(),
                min = acdbHostApplicationServices()->workingDatabase()->extmin();

        AcGePoint2d max_2d (max.x , max.y );
        AcGePoint2d min_2d (min.x , min.y );
        // now set the view centre point
        view.setCenterPoint (min_2d + (max_2d - min_2d) / 2.0);
        // now height and width of view
        view.setHeight(max_2d.y  - min_2d.y );
        view.setWidth (max_2d.x  - min_2d.x );
        // set the view
        acedSetCurrentView (&view, NULL);
        // updates the extents
        acdbHostApplicationServices()->workingDatabase()->updateExt(TRUE);
}

// This is command 'ZOOMWIN, by Fenton Webb [Apr/17/2002], DevTech, Autodesk
void  asdkzoomWin()
{
        AcGePoint3d max, min;
        // get the window coords
        int res = acedGetPoint (NULL, L"\nPick zoom window pnt : ",asDblArray(min));
        // if ok
        if (res == RTNORM)
        {
                res = acedGetCorner (asDblArray(min), L"\nPick other corner : ",asDblArray(max));
                // get the extents of the drawing
                AcDbViewTableRecord view;

                AcGePoint2d max_2d (max.x , max.y );
                AcGePoint2d min_2d (min.x , min.y );
                // now set the view centre point
                view.setCenterPoint (min_2d + (max_2d - min_2d) / 2.0);
                // now height and width of view
                view.setHeight(max_2d.y  - min_2d.y );
                view.setWidth (max_2d.x  - min_2d.x );
                // set the view
                acedSetCurrentView (&view, NULL);
                // updates the extents
                acdbHostApplicationServices()->workingDatabase()->updateExt(TRUE);
        }
}
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 69个

财富等级: 招财进宝

发表于 2017-3-5 21:08:30 | 显示全部楼层
啥也不说了,感谢楼主分享哇!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 28个

财富等级: 恭喜发财

发表于 2018-7-7 11:52:19 来自手机 | 显示全部楼层
这个好,恰好需要
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 28个

财富等级: 恭喜发财

发表于 2018-7-9 00:13:54 来自手机 | 显示全部楼层
版主,我没明年为什么为updateext,不要最后一个updateext有没有什么影响。我看手册里updateext会遍历所有对象再求ext,对象一多比如有几十万感觉影响速度啊
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-14 06:28 , Processed in 0.181868 second(s), 45 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表